#include "Task.h"
#include <stdio.h>
#include <assert.h>


//=============================================================
// Task Ʈ ʱȭ
CTaskList::CTaskList(int max_task_size, int max_num_task)
:	MaxTaskSize(max_task_size), MaxNumTask(max_num_task), 
	NumFreeTask(max_num_task)
{
	// Task ʱȭ ũ
	#define TASK(INDEX) ((CTask*)(buf+max_task_size*(INDEX)))

	// Task ޸ Ȯ
	char* buf=new char[max_task_size*(max_num_task+2)];

	// Active task Ʈ ʱȭ
	ActiveTask=TASK(0);
	ActiveTask->Prev=ActiveTask->Next=ActiveTask;

	// Free task Ʈ ʱȭ
	FreeTask=TASK(1);
	for (int i=1; i<max_num_task+1; i++) {
		TASK(i)->Next=TASK(i+1);
	}
	TASK(max_num_task+1)->Next=FreeTask;
}


//=============================================================
// Task 
// Free task Ʈ 󿡼 ޸  պκп CTask ġѴ
//  Ŭ ڸ ȣ Ŀ
// ޸  պκп CTask ġǴ  ƴϴ.
// ó new ڷ ,
// ó  Ҹڿ delete .

// new ó
void* CTask::operator_new(size_t t, CTaskList* task_list) {

	// Ŭ ũⰡ ִ ũ⸦  .
	assert(t<=(size_t)task_list->MaxTaskSize);

	// Free task    NULL ȯ
	if (task_list->NumFreeTask<=0) return NULL;

	// Free task ϳ 
	CTask* task=task_list->FreeTask->Next;
	task_list->FreeTask->Next=task->Next;
	task_list->NumFreeTask--;
	
	// ڷ
	return task;
}

// 
CTask::CTask(CTaskList* task_list)
:	TaskList(task_list)
{

	// Task Active task Ʈ ִ´.
	Prev=task_list->ActiveTask->Prev;
	Next=task_list->ActiveTask;
	Prev->Next=Next->Prev=this;
}


//=============================================================
// Task 

// Ҹ
CTask::~CTask() {

	// Task Active task Ʈ Ѵ
	Prev->Next=Next;
	Next->Prev=Prev;
}

// delete ó
void CTask::operator_delete(void* p, CTaskList* task_list) {

	// Task
	CTask* task=(CTask*)p;

	// Task Free task Ʈ ִ´.
	task->Next=task_list->FreeTask->Next;
	task_list->FreeTask->Next=task;
	task_list->NumFreeTask++;

	// Free task  ִ task   .
	// (delete ߺȣ )
	assert(task_list->NumFreeTask<=task_list->MaxNumTask);
}


//=============================================================
//  Task 
void CTaskList::DeleteTask() {
	for (CTaskIter i(this); i.HasNext(); i.Next(), i.Remove()) ;
}
